/////////////////////////////////////////////////////////////////////////////////
//
// Aurora C++ Library
// Copyright (c) 2012-2015 Jan Haller
// 
// This software is provided 'as-is', without any express or implied
// warranty. In no event will the authors be held liable for any damages
// arising from the use of this software.
// 
// Permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions:
// 
// 1. The origin of this software must not be misrepresented; you must not
//    claim that you wrote the original software. If you use this software
//    in a product, an acknowledgment in the product documentation would be
//    appreciated but is not required.
// 
// 2. Altered source versions must be plainly marked as such, and must not be
//    misrepresented as being the original software.
// 
// 3. This notice may not be removed or altered from any source distribution.
//
/////////////////////////////////////////////////////////////////////////////////

// This header exists for documentation purposes only.


/// @mainpage
///
/// @section welcome Welcome
/// Welcome to the documentation of the Aurora Library. Here you'll find a reference for all types, functions, variables and macros
/// of the public API. 
///

/// @defgroup Dispatch Dispatch
/// @brief Facilities for single and double dispatching at runtime, as an extension of C++ virtual functions.

/// @defgroup Meta Meta
/// @brief Utilities for template and preprocessor metaprogramming.

/// @defgroup SmartPtr SmartPtr
/// @brief Smart pointers with value semantics supporting polymorphic deep copies.

/// @defgroup Tools Tools
/// @brief C++ utility and idioms, such as noncopyable base classes, foreach macros or safe bool idiom.
